"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var core_1 = require("@angular/core");
var utils_1 = require("../utils/utils");
var PhonePipe = (function () {
    function PhonePipe() {
    }
    PhonePipe.prototype.transform = function (input, locale, showCountryCode) {
        if (locale === void 0) { locale = 'en-US'; }
        if (showCountryCode === void 0) { showCountryCode = false; }
        if (utils_1.isNil(input) || !/^[a-zA-Z]{2}-[a-zA-Z]{2}$/.test(locale))
            return input;
        var strInput = input.replace(/[^0-9]/g, '');
        var splittedLocale = locale.split('-');
        var formattedLocale = splittedLocale[0].toLowerCase() + "-" + splittedLocale[1].toUpperCase();
        var phoneObj = utils_1.getPhone(formattedLocale);
        if (utils_1.isNil(phoneObj) || strInput.length < phoneObj.minLength)
            return input;
        var pattern = phoneObj.pattern;
        var matches = strInput.match(pattern);
        var formattedPhone = '';
        switch (formattedLocale) {
            case 'en-US':
            case 'pt-BR':
                formattedPhone = "(" + matches[2] + ") " + matches[3] + "-" + matches[4];
                break;
            default:
                break;
        }
        if (showCountryCode) {
            formattedPhone = phoneObj.countryCode + " " + formattedPhone;
        }
        return formattedPhone;
    };
    return PhonePipe;
}());
PhonePipe = __decorate([
    core_1.Pipe({ name: 'phone' })
], PhonePipe);
exports.PhonePipe = PhonePipe;
//# sourceMappingURL=phone.pipe.js.map